// BndDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Bnd.h"
#include "BndDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "PropDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CBndDlg dialog

CBndDlg::CBndDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBndDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBndDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bBndChecked=TRUE;
	m_bPntChecked=TRUE;
}

void CBndDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBndDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBndDlg, CDialog)
	//{{AFX_MSG_MAP(CBndDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FRM_BND, OnFrmBnd)
	ON_COMMAND(ID_LOGO_PNT, OnLogoPnt)
	ON_COMMAND(ID_PROPERTIES, OnProperties)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBndDlg message handlers

BOOL CBndDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	SetFrameBounder(TRUE);
	m_Pnt.SetText("Hello from CLogoPainter");
	SetLogoPainter(TRUE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBndDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBndDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CBndDlg::GetMinMaxSize(CSize& min, CSize& max)
{
	CWnd* pMinFrm=GetDlgItem(IDC_FRM_MIN);
	if(!pMinFrm)
		return FALSE;
	WINDOWPLACEMENT wpl={0};
	GetWindowPlacement(&wpl);
	RECT rcClient={0};
	GetClientRect(&rcClient);
	CRect rectClient(rcClient);
	INT nMnuHeight=::GetSystemMetrics(SM_CYMENUSIZE);
	INT nFrameHeight=::GetSystemMetrics(SM_CYSIZE)+::GetSystemMetrics(SM_CYFRAME);
	CRect rectTotal(wpl.rcNormalPosition);
	CSize sizeOffs(rectTotal.Width()-rectClient.Width(),rectTotal.Height()-rectClient.Height());
	pMinFrm->GetWindowPlacement(&wpl);
	min.cx=wpl.rcNormalPosition.right+wpl.rcNormalPosition.left+sizeOffs.cx;
	min.cy=wpl.rcNormalPosition.bottom-wpl.rcNormalPosition.top+2*nMnuHeight+nFrameHeight;
	CWnd* pMaxFrm=GetDlgItem(IDC_FRM_MAX);
	if(!pMaxFrm)
		return FALSE;
	pMaxFrm->GetWindowPlacement(&wpl);
	max.cx=wpl.rcNormalPosition.right+wpl.rcNormalPosition.left+sizeOffs.cx;
	max.cy=wpl.rcNormalPosition.bottom-wpl.rcNormalPosition.top+2*nMnuHeight+nFrameHeight;
	return TRUE;
}

RECT CBndDlg::GetLogoRect()
{
	RECT rc={0};
	CWnd* pWnd=GetDlgItem(IDC_LOGO);
	ASSERT(pWnd);
	if(!pWnd)
		return rc;
	WINDOWPLACEMENT wpl={0};
	pWnd->GetWindowPlacement(&wpl);
	rc=wpl.rcNormalPosition; 
	return rc;
}


void CBndDlg::OnFrmBnd() 
{
	SetFrameBounder(!m_bBndChecked);
}

void CBndDlg::OnLogoPnt() 
{
	SetLogoPainter(!m_bPntChecked);
}


void CBndDlg::OnProperties() 
{
	CPropDlg dlg;
	dlg.m_bBnd=m_bBndChecked;
	dlg.m_bPnt=m_bPntChecked;
	dlg.m_csText=m_Pnt.GetText();
	if(dlg.DoModal()==IDOK)
	{
		if(m_bBndChecked!=dlg.m_bBnd)	// if state changed
			SetFrameBounder(dlg.m_bBnd);
		if(m_bPntChecked!=dlg.m_bPnt)
			SetLogoPainter(dlg.m_bPnt);
		m_Pnt.SetText(dlg.m_csText);
	}
	
}

BOOL CBndDlg::SetFrameBounder(BOOL bSet)
{
	m_bBndChecked=bSet;
	CMenu* pMenu=GetMenu();
	if(pMenu)
		pMenu->CheckMenuItem(ID_FRM_BND,m_bBndChecked ? MF_CHECKED : MF_UNCHECKED); 
	if(m_bBndChecked)
	{
		CSize min,max;
		GetMinMaxSize(min,max);
		return m_Bnd.Initialize(m_hWnd,min,max);
	}
	else
		return m_Bnd.Terminate();
}

BOOL CBndDlg::SetLogoPainter(BOOL bSet)
{
	m_bPntChecked=bSet;
	CMenu* pMenu=GetMenu();
	if(pMenu)
		pMenu->CheckMenuItem(ID_LOGO_PNT,m_bPntChecked ? MF_CHECKED : MF_UNCHECKED); 
	if(m_bPntChecked)
		return m_Pnt.Initialize(m_hWnd,m_Pnt.GetText(),GetLogoRect());
	else
		return m_Pnt.Terminate();
}
