#include "FrmBnd.h"

SIZE CFrameBounder::szNull={0,0};
SIZE CFrameBounder::szInfinite={0x7fffffff,0x7fffffff};

LRESULT CFrameBounder::PreWndProc(HWND _hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LONG& nMinWidth=szMin.cx;
	LONG& nMinHeight=szMin.cy;
	LONG& nMaxWidth=szMax.cx;
	LONG& nMaxHeight=szMax.cy;
	if(uMsg==WM_SIZING)
	{
		RECT* pRC=(RECT*)lParam;
		if( nMinWidth && pRC->right <= pRC->left+nMinWidth )	// width less than minimal
		{
			if(wParam==WMSZ_RIGHT || wParam==WMSZ_TOPRIGHT || wParam==WMSZ_BOTTOMRIGHT)
				pRC->right = pRC->left+nMinWidth;
			if(wParam==WMSZ_LEFT || wParam==WMSZ_TOPLEFT || wParam==WMSZ_BOTTOMLEFT)
				pRC->left = pRC->right-(nMinWidth);
		}
		if(	nMinHeight && pRC->bottom <= pRC->top+nMinHeight )	// height less than minimal
		{
			if(wParam==WMSZ_BOTTOM || wParam==WMSZ_BOTTOMRIGHT || wParam==WMSZ_BOTTOMLEFT)
				pRC->bottom = pRC->top+nMinHeight;
			if(wParam==WMSZ_TOP || wParam==WMSZ_TOPRIGHT || wParam==WMSZ_TOPLEFT)
				pRC->top = pRC->bottom-nMinHeight;
		}
		if( nMaxWidth!=szInfinite.cx && pRC->right >= pRC->left+nMaxWidth )	// height less than maximal
		{
			if(wParam==WMSZ_RIGHT || wParam==WMSZ_TOPRIGHT || wParam==WMSZ_BOTTOMRIGHT)
				pRC->right = pRC->left+nMaxWidth;
			if(wParam==WMSZ_LEFT || wParam==WMSZ_TOPLEFT || wParam==WMSZ_BOTTOMLEFT)
				pRC->left = pRC->right-nMaxWidth;
		}
		if(	nMaxHeight!=szInfinite.cy && pRC->bottom >= pRC->top+nMaxHeight )	// height greater than maximal
		{
			if(wParam==WMSZ_BOTTOM || wParam==WMSZ_BOTTOMRIGHT || wParam==WMSZ_BOTTOMLEFT)
				pRC->bottom = pRC->top+nMaxHeight;
			if(wParam==WMSZ_TOP || wParam==WMSZ_TOPRIGHT || wParam==WMSZ_TOPLEFT)
				pRC->top = pRC->bottom-nMaxHeight;
		}
		GetOldWndProc()(_hWnd,uMsg,wParam,lParam);
		return 1;
	}
	return 0;
}

CFrameBounder::CFrameBounder(HWND hWnd,SIZE& szMin,SIZE& szMax)
{
	Initialize(hWnd,szMin,szMax); 
}

CFrameBounder::~CFrameBounder()
{
	;
}

BOOL CFrameBounder::Initialize(HWND _hWnd,SIZE& _szMin,SIZE& _szMax)
{
	CMsgHandler::Initialize(_hWnd);
	szMin=_szMin; szMax=_szMax;
	// initial bounds check
	WINDOWPLACEMENT wpl={0};
	::GetWindowPlacement(hWnd,&wpl);
	if(wpl.rcNormalPosition.right-wpl.rcNormalPosition.left < szMin.cx)
		wpl.rcNormalPosition.right=wpl.rcNormalPosition.left+szMin.cx;
	if(wpl.rcNormalPosition.bottom-wpl.rcNormalPosition.top < szMin.cy)
		wpl.rcNormalPosition.bottom=wpl.rcNormalPosition.top+szMin.cy;
	if(wpl.rcNormalPosition.right-wpl.rcNormalPosition.left > szMax.cx)
		wpl.rcNormalPosition.right=wpl.rcNormalPosition.left+szMax.cx;
	if(wpl.rcNormalPosition.bottom-wpl.rcNormalPosition.top > szMax.cy)
		wpl.rcNormalPosition.bottom=wpl.rcNormalPosition.top+szMax.cy;
	::SetWindowPlacement(hWnd,&wpl);
	return TRUE;
}

BOOL CFrameBounder::Terminate()
{
	CMsgHandler::Terminate();
	return TRUE;
}

void CFrameBounder::SetMinSize(SIZE& _szMin)
{ 
	szMin.cx=max(_szMin.cx,0);
	szMin.cy=max(_szMin.cy,0);
}

SIZE CFrameBounder::GetMinSize()
{ 
	return szMin;
}

void CFrameBounder::SetMaxSize(SIZE& _szMax)
{
	szMax.cx=max(_szMax.cx,szMin.cx);
	szMax.cy=max(_szMax.cy,szMin.cy);
}

SIZE CFrameBounder::GetMaxSize(SIZE& _szMax)
{
	return szMax;
}
