///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// Module contains class CFrameBounder derived from CMsgHandler.
//// Class overrides WndProc function to check window Max and Min sizes when
//// window is to be resized
////
//// author - Sholomov D.L. (02.07.2001)
//// Cognitive Technologies Ltd. 
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _FRM_BND_H
#define _FRM_BND_H

#ifndef _WINDOWS_
#include "windows.h" 
#endif

#pragma warning (disable:4786)

#include <map>
using namespace std;

#include "MsgHndlr.h"

class CFrameBounder : public CMsgHandler
{
	static SIZE szNull;
	static SIZE szInfinite;
	SIZE szMin;
	SIZE szMax;
protected:
	// Overridables
	virtual LRESULT PreWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
public:
	// Construction
	CFrameBounder(HWND hWnd=NULL,SIZE& szMin=szNull,SIZE& szMax=szInfinite); 
	virtual ~CFrameBounder();
	// Initialization
	BOOL Initialize(HWND hWnd=NULL,SIZE& rcMin=szNull,SIZE& szMax=szInfinite);
	BOOL Terminate();
	// Properties
	void SetMinSize(SIZE& _szMin);
	SIZE GetMinSize();
	void SetMaxSize(SIZE& _szMax);
	SIZE GetMaxSize(SIZE& _szMax);
};

#endif	// _FRM_BND_H