#include "LogoPnt.h"

#define SAFE_STR( str ) (str ? str : "")

CLogoPainter::CLogoPainter(HWND _hWnd,const char* pText,RECT& _rcText)
{
	Initialize(_hWnd,pText,_rcText);
}

BOOL CLogoPainter::Initialize(HWND _hWnd,const char* pText,RECT& _rcText)
{ 
	CMsgHandler::Initialize(_hWnd);
	rcText=_rcText;
	SetText(SAFE_STR(pText));
	return TRUE;
}

BOOL CLogoPainter::Terminate()
{ 
	CMsgHandler::Terminate();
	Redraw();
	return TRUE;
}

LRESULT CLogoPainter::PostWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if(uMsg==WM_PAINT)
	{
		HDC hDC=::GetDC(hWnd);
		if(hDC)
			::DrawText(hDC,sText.c_str(),sText.length(),&rcText, DT_CENTER  | DT_VCENTER | DT_SINGLELINE );
	}
	return 0;
}

void CLogoPainter::Redraw()
{
	if(IsWindow(hWnd))
	{
		::InvalidateRect(hWnd,&rcText,TRUE);
		::UpdateWindow(hWnd);
	}
}

RECT CLogoPainter::rcNull={0};

void CLogoPainter::SetText(const char* pText,BOOL bRedraw)
{ 
	sText=pText;
	if(bRedraw)
		Redraw();
}

const char* CLogoPainter::GetText()
{
	return sText.c_str();
}

